<?php

namespace STM\Competition\Category;

use \Exception;
use STM\StmFactory;

/**
 * Test class for CompetitionCategoryValidator.
 * Generated by PHPUnit on 2011-12-08 at 18:26:22.
 * @group competition_category
 */
class CompetitionCategoryValidatorTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $categories;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), new Exception());
        $this->categories = StmFactory::find()->CompetitionCategory->findAll();
    }

    protected function tearDown() {}

    public function testCheck_create() {        
        foreach ($this->bad_values as $value) {
            $this->assert_bad_arguments('checkCreate', $value);
            $this->assert_bad_arguments('checkCreate', array('name' => $value, 'description' => $value, 'id_parent_category' => $value));
        }
        
        // parent category must be existing category or null
        CompetitionCategoryValidator::init();           
        parent::assertTrue(CompetitionCategoryValidator::checkCreate(array('name' => '123456789012345678901234567890123456789012345', 'description' => 'more than 5 letters', 'id_parent_category' => null)));        
        foreach ($this->categories as $category) {
            parent::assertTrue(CompetitionCategoryValidator::checkCreate(array(
                'name' => '123456789012345678901234567890123456789012345', 
                'description' => 'more than 5 letters', 
                'id_parent_category' => $category->getId())));        
        }
    }

    public function testCheck_update() {
        foreach ($this->categories as $category) {
            CompetitionCategoryValidator::setCategory($category);
            $valid = array(
                'name' => $category->__toString(),
                'description' => $category->getDescription(),
                'id_parent_category' => $category->getIdParent(),
            );
            // different from current values
            $this->assert_bad_arguments('checkUpdate', $valid);
            
            // at least one change (in name or club)
            $valid['name'] .= '*x*';
            parent::assertTrue(CompetitionCategoryValidator::checkUpdate($valid));
            
            CompetitionCategoryValidator::resetCategory();
        }
    }

    public function testCheck_name() {
        CompetitionCategoryValidator::init();
        // length = <3, 50>
        parent::assertTrue(CompetitionCategoryValidator::checkName('dsadsa 123ok'));
        parent::assertTrue(CompetitionCategoryValidator::checkName('5968741524795+654684'));

        foreach($this->bad_values as $value) {
            $this->assert_bad_arguments('checkName', $value);
        }
    }

    public function testCheck_description() {
        CompetitionCategoryValidator::init();
        // length = <5, 200>
        parent::assertTrue(CompetitionCategoryValidator::checkDescription('dsadsa 123ok'));
        parent::assertTrue(CompetitionCategoryValidator::checkDescription('5968741524795+654684'));

        foreach($this->bad_values as $value) {
            $this->assert_bad_arguments('checkDescription', $value);
        }
    }

    public function testCheck_parent_category() {        
        foreach ($this->categories as $category) {
            CompetitionCategoryValidator::setCategory($category);
            // category cannot be own parent
            $this->assert_bad_arguments('checkParentCategory', $category->getId());
            // it has to be different category or null
            foreach ($this->categories as $parent_category) {                
                if ($parent_category->getId() != $category->getId() && $parent_category->getId() != $category->getIdParent()) {
                    parent::assertTrue(CompetitionCategoryValidator::checkParentCategory($parent_category->getId()));
                }
                parent::assertTrue(CompetitionCategoryValidator::checkParentCategory(null));
                // it must be numeric or null                
                $this->assert_bad_arguments('checkParentCategory', new Exception());
            }
            CompetitionCategoryValidator::resetCategory();            
        }
    }

    private function assert_bad_arguments($method, $data) {
        CompetitionCategoryValidator::init();
        parent::assertFalse(CompetitionCategoryValidator::$method($data));
        CompetitionCategoryValidator::init();
    }

}

?>
